zoukankan      html  css  js  c++  java
  • Intelligence System (hdu 3072 强联通缩点+贪心)

    Intelligence System

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
    Total Submission(s): 1650    Accepted Submission(s): 722


    Problem Description
    After a day, ALPCs finally complete their ultimate intelligence system, the purpose of it is of course for ACM ... ...
    Now, kzc_tc, the head of the Intelligence Department (his code is once 48, but now 0), is sudden obtaining important information from one Intelligence personnel. That relates to the strategic direction and future development of the situation of ALPC. So it need for emergency notification to all Intelligence personnel, he decides to use the intelligence system (kzc_tc inform one, and the one inform other one or more, and so on. Finally the information is known to all).
    We know this is a dangerous work. Each transmission of the information can only be made through a fixed approach, from a fixed person to another fixed, and cannot be exchanged, but between two persons may have more than one way for transferring. Each act of the transmission cost Ci (1 <= Ci <= 100000), the total cost of the transmission if inform some ones in our ALPC intelligence agency is their costs sum.
    Something good, if two people can inform each other, directly or indirectly through someone else, then they belong to the same branch (kzc_tc is in one branch, too!). This case, it’s very easy to inform each other, so that the cost between persons in the same branch will be ignored. The number of branch in intelligence agency is no more than one hundred.
    As a result of the current tensions of ALPC’s funds, kzc_tc now has all relationships in his Intelligence system, and he want to write a program to achieve the minimum cost to ensure that everyone knows this intelligence.
    It's really annoying!
     

    Input
    There are several test cases.
    In each case, the first line is an Integer N (0< N <= 50000), the number of the intelligence personnel including kzc_tc. Their code is numbered from 0 to N-1. And then M (0<= M <= 100000), the number of the transmission approach.
    The next M lines, each line contains three integers, X, Y and C means person X transfer information to person Y cost C.
     

    Output
    The minimum total cost for inform everyone.
    Believe kzc_tc’s working! There always is a way for him to communicate with all other intelligence personnel.
     

    Sample Input
    3 3 0 1 100 1 2 50 0 2 100 3 3 0 1 100 1 2 50 2 1 100 2 2 0 1 50 0 1 100
     

    Sample Output
    150 100 50
     

    Source
     

    Recommend
    lcy   |   We have carefully selected several similar problems for you:  3069 3077 3070 3071 3073 
     

    题意:n个人m个单向关系。如今要通知全部的人,两个人之间联系有费用,求最小费用,处于同一个联通块的两个人之间通讯不须要花费。

    思路:先建图使用Tarjan算法缩点,然后依据题意我们应该求缩点后新图的最小树形图,但是这里不是必需,为什么?细致想一想,首先题意说总是有解,所以最小树形图一定存在。那么我们对于每个点在它的全部入边中选择一个花费最小的入边(入度为零的点除外)那么答案就是每个点的最小花费之和。这样贪心是可行的,由于在这个过程中不会出现环,非常easy想到,假设出现了环那么这个环就又是一个联通块了,但是我们之前已经求出了联通块,保证了新图中没有环。

    代码:

    #include <iostream>
    #include <cstdio>
    #include <cstring>
    #include <algorithm>
    #include <cmath>
    #include <string>
    #include <map>
    #include <stack>
    #include <vector>
    #include <set>
    #include <queue>
    #pragma comment (linker,"/STACK:102400000,102400000")
    #define mod 1000000009
    #define INF 0x3f3f3f3f
    #define pi acos(-1.0)
    #define eps 1e-6
    #define lson rt<<1,l,mid
    #define rson rt<<1|1,mid+1,r
    #define FRE(i,a,b)  for(i = a; i <= b; i++)
    #define FREE(i,a,b) for(i = a; i >= b; i--)
    #define FRL(i,a,b)  for(i = a; i < b; i++)
    #define FRLL(i,a,b) for(i = a; i > b; i--)
    #define mem(t, v)   memset ((t) , v, sizeof(t))
    #define sf(n)       scanf("%d", &n)
    #define sff(a,b)    scanf("%d %d", &a, &b)
    #define sfff(a,b,c) scanf("%d %d %d", &a, &b, &c)
    #define pf          printf
    #define DBG         pf("Hi
    ")
    typedef long long ll;
    using namespace std;
    
    const int MAXN = 50010;//点数
    const int MAXM = 500010;//边数
    
    struct Edge
    {
        int to,c,next;
    }edge[MAXM];
    
    int head[MAXN],tot;
    int Low[MAXN],DFN[MAXN],Stack[MAXN],Belong[MAXN];//Belong数组的值是1~scc
    int Index,top;
    int scc;//强联通分量的个数
    bool Instack[MAXN];
    int num[MAXN];//各个强联通分量包括的点的个数,数组编号为1~scc
    //num数组不一定须要,结合实际情况
    
    void addedge(int u,int v,int c)
    {
        edge[tot].to=v;
        edge[tot].c=c;
        edge[tot].next=head[u];
        head[u]=tot++;
    }
    
    void Tarjan(int u)
    {
        int v;
        Low[u]=DFN[u]=++Index;
        Stack[top++]=u;
        Instack[u]=true;
        for (int i=head[u];i+1;i=edge[i].next)
        {
            v=edge[i].to;
            if (!DFN[v])
            {
                Tarjan(v);
                if (Low[u]>Low[v]) Low[u]=Low[v];
            }
            else if (Instack[v]&&Low[u]>DFN[v])
                Low[u]=DFN[v];
        }
        if (Low[u]==DFN[u])
        {
            scc++;
            do{
                v=Stack[--top];
                Instack[v]=false;
                Belong[v]=scc;
                num[scc]++;
            }while (v!=u);
        }
    }
    
    void solve(int N)
    {
        memset(DFN,0,sizeof(DFN));
        memset(Instack,false,sizeof(Instack));
        memset(num,0,sizeof(num));
        Index=scc=top=0;
        for (int i=1;i<=N;i++)      //点的编号从1開始
            if (!DFN[i])
                Tarjan(i);
    }
    
    int n,m;
    int d[MAXN],in[MAXN];
    
    void init()
    {
        tot=0;
        memset(head,-1,sizeof(head));
        memset(d,INF,sizeof(d));
        memset(in,0,sizeof(in));
    }
    
    int main()
    {
    #ifndef ONLINE_JUDGE
        freopen("C:/Users/asus1/Desktop/IN.txt","r",stdin);
    #endif
        int i,j,u,v,c;
        while (~sff(n,m))
        {
            init();
            for (i=0;i<m;i++)
            {
                sfff(u,v,c);
                u++;v++;
                addedge(u,v,c);
            }
            solve(n);
            int ans=0;
            for (u=1;u<=n;u++)
            {
                for (i=head[u];~i;i=edge[i].next)
                {
                    int v=edge[i].to;
                    if (Belong[u]!=Belong[v])
                        in[Belong[v]]++;
                }
            }
            for (u=1;u<=n;u++)
            {
                for (j=head[u];~j;j=edge[j].next)
                {
                    int v=edge[j].to;
                    if (Belong[u]!=Belong[v])
                        d[Belong[v]]=min(d[Belong[v]],edge[j].c);
                }
            }
            for (i=1;i<=scc;i++)
            {
                if (in[i]==0) continue;
                ans+=d[i];
            }
            pf("%d
    ",ans);
        }
        return 0;
    }
    



  • 相关阅读:
    葡萄庄园 [图论]
    硬币游戏 [博弈论, 思维题]
    烹饪 [容斥]
    BZOJ1597 [Usaco2008 Mar]土地购买 [斜率优化]
    TCP IP协议
    soap协议
    xml的语法规则
    fiddler的使用
    常见默认端口
    智能休眠时间的使用
  • 原文地址:https://www.cnblogs.com/claireyuancy/p/6693748.html
Copyright © 2011-2022 走看看